<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en"><head>

<meta charset="utf-8">
<meta name="generator" content="quarto-1.5.40">

<meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes">


<title>Zotero</title>
<style>
code{white-space: pre-wrap;}
span.smallcaps{font-variant: small-caps;}
div.columns{display: flex; gap: min(4vw, 1.5em);}
div.column{flex: auto; overflow-x: auto;}
div.hanging-indent{margin-left: 1.5em; text-indent: -1.5em;}
ul.task-list{list-style: none;}
ul.task-list li input[type="checkbox"] {
  width: 0.8em;
  margin: 0 0.8em 0.2em -1em; /* quarto-specific, see https://github.com/quarto-dev/quarto-cli/issues/4556 */ 
  vertical-align: middle;
}
</style>


<script src="Zotero_files/libs/clipboard/clipboard.min.js"></script>
<script src="Zotero_files/libs/quarto-html/quarto.js"></script>
<script src="Zotero_files/libs/quarto-html/popper.min.js"></script>
<script src="Zotero_files/libs/quarto-html/tippy.umd.min.js"></script>
<script src="Zotero_files/libs/quarto-html/anchor.min.js"></script>
<link href="Zotero_files/libs/quarto-html/tippy.css" rel="stylesheet">
<link href="Zotero_files/libs/quarto-html/quarto-syntax-highlighting.css" rel="stylesheet" id="quarto-text-highlighting-styles">
<script src="Zotero_files/libs/bootstrap/bootstrap.min.js"></script>
<link href="Zotero_files/libs/bootstrap/bootstrap-icons.css" rel="stylesheet">
<link href="Zotero_files/libs/bootstrap/bootstrap.min.css" rel="stylesheet" id="quarto-bootstrap" data-mode="light">


</head>

<body class="fullcontent">

<div id="quarto-content" class="page-columns page-rows-contents page-layout-article">

<main class="content" id="quarto-document-content">

<header id="title-block-header" class="quarto-title-block default">
<div class="quarto-title">
<h1 class="title">Zotero</h1>
</div>



<div class="quarto-title-meta">

    
  
    
  </div>
  


</header>


<section id="zotero-anleitung" class="level1">
<h1>Zotero Anleitung</h1>
<section id="zotero-in-onlyoffice" class="level2">
<h2 class="anchored" data-anchor-id="zotero-in-onlyoffice">Zotero in OnlyOffice</h2>
<p>Install plugin Zotero</p>
<div class="quarto-figure quarto-figure-center">
<figure class="figure">
<p><img src="Bilder/onlyoffice.png" class="img-fluid figure-img"></p>
<figcaption>Zotero Plugin</figcaption>
</figure>
</div>
<div class="quarto-figure quarto-figure-center">
<figure class="figure">
<p><img src="Bilder/onlyoffice2.png" class="img-fluid figure-img"></p>
<figcaption>Zotero API-Key</figcaption>
</figure>
</div>
</section>
<section id="zotero-in-r-studio-installieren" class="level2">
<h2 class="anchored" data-anchor-id="zotero-in-r-studio-installieren">Zotero in R Studio installieren</h2>
<p><code>https://gsverhoeven.github.io/post/zotero-rmarkdown-csl/</code></p>
<p>Now we need a connection to Zotero. There are two Rstudio Addins that compete for this functionality, citr and rbbt. We use rbbt.</p>
<p><code>remotes::install_github("paleolimbot/rbbt")</code></p>
<p>After installing and restarting Rstdio, the rbbt addin can be found under Addins. Now since citing stuff is a common activity while writing a paper, we want a keyboard shortcut for this. I put it under CTRL + K where K stand for errr, Knowledge ?</p>
<p>To bind rbbt to a particular keyboard shortcut, do the following: 1. in RStudio, choose Tools –&gt; Modify Keyboard Shortcuts. 2. Type zotero to filter out the Zotero plugin. 3. Click on the ‘Shortcut’ field for the ‘Insert Zotero citation’ addin row 4. Type the desired shortcut keys.</p>
<p>In Rstudio, we can now press CTRL+K, type the name of the first author, select the citation, press enter, and have the citation key added to our .Rmd document.</p>
</section>
<section id="better-bibtex" class="level2">
<h2 class="anchored" data-anchor-id="better-bibtex">Better BibTeX</h2>
<p>Better BibTeX (BBT) ist ein Plugin für Zotero und Juris-M, das die Verwaltung bibliografischer Daten erleichtert, besonders für Personen, die Dokumente mit textbasierten Toolchains verfassen (z.B. LaTeX / Markdown).</p>
<p>Herunterladen von <code>https://github.com/retorquere/zotero-better-bibtex/releases/tag/v6.7.202</code></p>
<p><code>zotero-better-bibtex-6.7.202.xpi</code></p>
<section id="installation" class="level3">
<h3 class="anchored" data-anchor-id="installation">Installation:</h3>
<ol type="1">
<li>Im Hauptmenü zu Werkzeuge -&gt; Add-ons gehen</li>
<li>„Erweiterungen“ auswählen</li>
<li>Auf das Zahnrad in der oberen rechten Ecke klicken und „Add-on aus Datei installieren…“ wählen</li>
<li>Die heruntergeladene .xpi-Datei auswählen, auf „Installieren“ klicken</li>
<li>Zotero neu starten</li>
</ol>
<p>Nach der Erstinstallation wird das Plugin automatisch auf neuere Versionen aktualisiert, sodass dieser Vorgang nur einmal durchgeführt werden muss.</p>
<div class="quarto-figure quarto-figure-center">
<figure class="figure">
<p><img src="Bilder/Werkzeug.png" class="img-fluid figure-img"></p>
<figcaption>Pfad</figcaption>
</figure>
</div>
<div class="quarto-figure quarto-figure-center">
<figure class="figure">
<p><img src="Bilder/betterbib.png" class="img-fluid figure-img"></p>
<figcaption>BetterBib</figcaption>
</figure>
</div>
<p>Das Standardmuster für die Schlüsselgenerierung ist <code>auth.lower + shorttitle(3,3) + year</code>. Wenn Sie Arbeiten haben, die Schlüssel verwenden, die vom Standardschlüsselgenerator der Zotero Bib(La)TeX-Exporte erzeugt wurden, sollten Sie stattdessen zotero.clean verwenden, um die Migration von bestehenden Exporten für Benutzer, die zuvor die Standard-Zotero Bib(La)TeX-Exporte verwendet haben, zu erleichtern.</p>
<p><code>auth.lower + shorttitle(3,3) + year</code></p>
<p>bedeutet: Nachname des ersten Autors ohne Leerzeichen, in Kleinbuchstaben aufgrund des .lower Filters. Die ersten n (Standard: 3) Wörter des Titels, wobei die ersten m (Standard: 0) davon groß geschrieben werden. Veröffentlichungsjahr, falls vorhanden, ein Buchstabenanhang (a, b, c, etc.) im Falle eines Konflikts (dieser Teil wird immer hinzugefügt, Sie können ihn nicht deaktivieren, obwohl Sie ihn in einen Zotero-ähnlichen numerischen Wert ändern können).</p>
<p>Wenn Sie es komplizierter möchten, können Sie mehrere Muster durch ein Semikolon (;) oder senkrechten Strich (|) getrennt festlegen, wobei das erste angewendet wird, das eine nicht-leere Zeichenfolge liefert. Wenn alle eine leere Zeichenfolge zurückgeben, wird ein zufälliger Schlüssel generiert.</p>
</section>
<section id="parameter" class="level3">
<h3 class="anchored" data-anchor-id="parameter">Parameter:</h3>
<p><code>auth</code> Parameter: Die ersten n (Standard: alle) Zeichen des Nachnamens des m-ten (Standard: ersten) Autors.</p>
<p><code>authAuthEa</code> Parameter: Der Nachname der ersten beiden Autoren und „.ea“, wenn es mehr als zwei Autoren gibt.</p>
<p><code>authEtAl</code> Parameter: Der Nachname des ersten Autors und der Nachname des zweiten Autors, wenn es zwei Autoren gibt, oder „EtAl“, wenn es mehr als zwei gibt. Dies ist ähnlich wie auth.etal. Der Unterschied besteht darin, dass die Autoren nicht durch „.“ getrennt sind und im Falle von mehr als 2 Autoren „EtAl“ statt „.etal“ hinzugefügt wird.</p>
<p><code>authEtal2</code> Parameter: Der Nachname des ersten Autors und der Nachname des zweiten Autors, wenn es zwei Autoren gibt, oder „.etal“, wenn es mehr als zwei gibt.</p>
<p>´authForeIni` Parameter: Der Anfangsbuchstabe des Vornamens des ersten Autors.</p>
<p><code>authIni</code> Parameter: Der Anfang jedes Nachnamens der Autoren, wobei nicht mehr als n Zeichen (0 = alle) verwendet werden.</p>
<p><code>authorIni</code> Parameter: Die ersten 5 Zeichen des Nachnamens des ersten Autors und die Initialen der Nachnamen der übrigen Autoren.</p>
<p><code>authorLast</code> Parameter: Der Nachname des letzten Autors.</p>
<p><code>authorLastForeIni</code> Parameter: Der Anfangsbuchstabe des Vornamens des letzten Autors.</p>
<p><code>authorsAlpha</code> Parameter: Entspricht dem BibTeX-Stil „alpha“. Ein Autor: Die ersten drei Buchstaben des Nachnamens. Zwei bis vier Autoren: Anfangsbuchstaben der Nachnamen zusammengefügt. Mehr als vier Autoren: Anfangsbuchstaben der Nachnamen der ersten drei Autoren zusammengefügt. „+“ am Ende.</p>
<p><code>authorsn</code> Parameter: Die Nachnamen der ersten n (Standard: alle) Autoren.</p>
<p><code>authshort</code> Parameter: Der Nachname, wenn ein Autor/Editor angegeben ist; der erste Buchstabe der Nachnamen von bis zu drei Autoren, wenn mehr als ein Autor angegeben ist. Ein Pluszeichen wird hinzugefügt, wenn es mehr als drei Autoren gibt.</p>
<p><code>creators</code> Parameter: Autor/Editor-Informationen.</p>
<p><code>creatortypes</code> Parameter: Gibt eine durch Kommas getrennte Liste von Typ-Informationen der Ersteller für alle Ersteller des Elements in der Form &lt;1 oder 2&gt;<ersteller-typ> zurück, wobei 1 oder 2 einen 1-teiligen oder 2-teiligen Ersteller bezeichnet, und Ersteller-Typ ist einer von {{% citekey-formatters/creatortypes %}}, oder primary für den Haupt-Ersteller-Typ des Zotero-Elements. Die Liste wird vom Elementtyp vorangestellt, sodass sie z.B. so aussehen könnte: audioRecording:2performer,2performer,1composer.</ersteller-typ></p>
<p><code>date</code> Parameter: Das Datum der Veröffentlichung.</p>
<p><code>extra</code> Parameter: Ein Pseudofeld aus dem Zusatzfeld. Z.B. wenn Sie Original date: 1970 in Ihrem Zusatzfeld haben, können Sie es als extra(originalDate) abrufen, oder tex.shortauthor: APA, welches Sie mit extra(‘tex.shortauthor’) abrufen können. Jedes tex.-Feld wird erfasst, die anderen Felder können aus dieser Liste von Schlüsselnamen ausgewählt werden.</p>
<p><code>firstpage</code> Die Nummer der ersten Seite der Veröffentlichung (Vorsicht: dies wird die niedrigste Zahl im Seitenfeld zurückgeben, da BibTeX 7,41,73–97 oder 43+ erlaubt).</p>
<p><code>infix</code> Parameter: Eine Pseudo-Funktion, die das Zitationsschlüssel-Disambiguierungs-Infix mit einem sprintf-js-Formatspezifikator setzt, wenn ein Schlüssel generiert wird, der bereits existiert. Das Infix-Zeichen erscheint an der Stelle dieser Funktion in der Formel statt am Ende (wie postfix). Sie müssen genau einen der Platzhalter %(n)s (Nummer), %(a)s (Alpha, Kleinbuchstaben) oder %(A)s (Alpha, Großbuchstaben) einfügen. Für den Rest des Disambiguators können Sie Dinge wie Polsterung und zusätzlichen Text verwenden, wie sprintf-js es erlaubt. Mit start auf 1 gesetzt, wird der Disambiguator immer einbezogen, auch wenn kein Bedarf besteht, wenn keine Duplikate existieren. Das Standardformat ist %(a)s.</p>
<p><code>inspireHep</code> Holt den Schlüssel von inspire-hep basierend auf DOI oder arXiv ID.</p>
<p><code>item</code> Parameter: Gibt die interne Artikel-ID/Schlüssel zurück.</p>
<p><code>journal</code> Parameter: Gibt die Zeitschriftenabkürzung oder, falls nicht vorhanden, den Zeitschriftentitel zurück. Wenn „automatische Zeitschriftenabkürzung“ in den BBT-Einstellungen aktiviert ist, wird derselbe Abkürzungsfilter verwendet, den Zotero in der Textverarbeitungseinbindung verwendet. Sie könnten den abbr-Filter darauf anwenden. Das Abkürzungsverhalten kann als abbrev+auto (Standard), auto, abbrev oder full/off angegeben werden.</p>
<p><code>keyword</code> Parameter: Schlagwortnummer n.&nbsp;Hauptsächlich für die Kompatibilität mit älteren Versionen - die Reihenfolge der Schlagworte ist undefiniert.</p>
<p><code>language</code> Parameter: Prüft, ob das Element die angegebene Sprache hat, und überspringt zum nächsten Muster, wenn nicht.</p>
<p><code>lastpage</code> Die Nummer der letzten Seite der Veröffentlichung (Siehe den Hinweis zur firstpage).</p>
<p><code>library</code> Gibt den Namen der freigegebenen Gruppenbibliothek zurück oder nichts, wenn das Element in Ihrer persönlichen Bibliothek ist.</p>
<p><code>month</code> Der Monat der Veröffentlichung.</p>
<p><code>origdate</code> Das Originaldatum der Veröffentlichung.</p>
<p><code>origyear</code> Das Originaljahr der Veröffentlichung.</p>
<p><code>postfix</code> Parameter: Eine Pseudo-Funktion, die das Zitationsschlüssel-Disambiguierungs-Postfix mit einem sprintf-js-Formatspezifikator setzt, wenn ein Schlüssel generiert wird, der bereits existiert. Fügt dem Zitationsschlüssel sonst keinen Text hinzu. Sie müssen genau einen der Platzhalter %(n)s (Nummer), %(a)s (Alpha, Kleinbuchstaben) oder %(A)s (Alpha, Großbuchstaben) einfügen. Für den Rest des Disambiguators können Sie Dinge wie Polsterung und zusätzlichen Text verwenden, wie sprintf-js es erlaubt. Mit start auf 1 gesetzt, wird der Disambiguator immer einbezogen, auch wenn kein Bedarf besteht, wenn keine Duplikate existieren. Das Standardformat ist %(a)s.</p>
<p><code>shorttitle</code> Parameter: Die ersten n (Standard: 3) Wörter des Titels, wobei die ersten m (Standard: 0) davon groß geschrieben werden.</p>
<p><code>shortyear</code> Die letzten 2 Ziffern des Veröffentlichungsjahres.</p>
<p><code>title</code> Alle wichtigen Wörter des Titels groß schreiben und zusammenfügen. Zum Beispiel wird aus „An awesome paper on JabRef“ „AnAwesomePaperJabref“.</p>
<p><code>type</code> Parameter: Ohne Argumente gibt er den Elementtyp zurück. Wenn Argumente übergeben werden, wird geprüft, ob das Element von einem der angegebenen Typen ist, und zum nächsten Muster übersprungen, wenn nicht, z.B. type(book) + veryshorttitle | auth + year.</p>
<p><code>veryshorttitle</code> Parameter: Die ersten n Wörter des Titels, wobei die ersten m davon groß geschrieben werden.</p>
<p><code>year</code> Das Jahr der Veröffentlichung.</p>
</section>
</section>
</section>

</main>
<!-- /main column -->
<script id="quarto-html-after-body" type="application/javascript">
window.document.addEventListener("DOMContentLoaded", function (event) {
  const toggleBodyColorMode = (bsSheetEl) => {
    const mode = bsSheetEl.getAttribute("data-mode");
    const bodyEl = window.document.querySelector("body");
    if (mode === "dark") {
      bodyEl.classList.add("quarto-dark");
      bodyEl.classList.remove("quarto-light");
    } else {
      bodyEl.classList.add("quarto-light");
      bodyEl.classList.remove("quarto-dark");
    }
  }
  const toggleBodyColorPrimary = () => {
    const bsSheetEl = window.document.querySelector("link#quarto-bootstrap");
    if (bsSheetEl) {
      toggleBodyColorMode(bsSheetEl);
    }
  }
  toggleBodyColorPrimary();  
  const icon = "";
  const anchorJS = new window.AnchorJS();
  anchorJS.options = {
    placement: 'right',
    icon: icon
  };
  anchorJS.add('.anchored');
  const isCodeAnnotation = (el) => {
    for (const clz of el.classList) {
      if (clz.startsWith('code-annotation-')) {                     
        return true;
      }
    }
    return false;
  }
  const onCopySuccess = function(e) {
    // button target
    const button = e.trigger;
    // don't keep focus
    button.blur();
    // flash "checked"
    button.classList.add('code-copy-button-checked');
    var currentTitle = button.getAttribute("title");
    button.setAttribute("title", "Copied!");
    let tooltip;
    if (window.bootstrap) {
      button.setAttribute("data-bs-toggle", "tooltip");
      button.setAttribute("data-bs-placement", "left");
      button.setAttribute("data-bs-title", "Copied!");
      tooltip = new bootstrap.Tooltip(button, 
        { trigger: "manual", 
          customClass: "code-copy-button-tooltip",
          offset: [0, -8]});
      tooltip.show();    
    }
    setTimeout(function() {
      if (tooltip) {
        tooltip.hide();
        button.removeAttribute("data-bs-title");
        button.removeAttribute("data-bs-toggle");
        button.removeAttribute("data-bs-placement");
      }
      button.setAttribute("title", currentTitle);
      button.classList.remove('code-copy-button-checked');
    }, 1000);
    // clear code selection
    e.clearSelection();
  }
  const getTextToCopy = function(trigger) {
      const codeEl = trigger.previousElementSibling.cloneNode(true);
      for (const childEl of codeEl.children) {
        if (isCodeAnnotation(childEl)) {
          childEl.remove();
        }
      }
      return codeEl.innerText;
  }
  const clipboard = new window.ClipboardJS('.code-copy-button:not([data-in-quarto-modal])', {
    text: getTextToCopy
  });
  clipboard.on('success', onCopySuccess);
  if (window.document.getElementById('quarto-embedded-source-code-modal')) {
    // For code content inside modals, clipBoardJS needs to be initialized with a container option
    // TODO: Check when it could be a function (https://github.com/zenorocha/clipboard.js/issues/860)
    const clipboardModal = new window.ClipboardJS('.code-copy-button[data-in-quarto-modal]', {
      text: getTextToCopy,
      container: window.document.getElementById('quarto-embedded-source-code-modal')
    });
    clipboardModal.on('success', onCopySuccess);
  }
    var localhostRegex = new RegExp(/^(?:http|https):\/\/localhost\:?[0-9]*\//);
    var mailtoRegex = new RegExp(/^mailto:/);
      var filterRegex = new RegExp('/' + window.location.host + '/');
    var isInternal = (href) => {
        return filterRegex.test(href) || localhostRegex.test(href) || mailtoRegex.test(href);
    }
    // Inspect non-navigation links and adorn them if external
 	var links = window.document.querySelectorAll('a[href]:not(.nav-link):not(.navbar-brand):not(.toc-action):not(.sidebar-link):not(.sidebar-item-toggle):not(.pagination-link):not(.no-external):not([aria-hidden]):not(.dropdown-item):not(.quarto-navigation-tool):not(.about-link)');
    for (var i=0; i<links.length; i++) {
      const link = links[i];
      if (!isInternal(link.href)) {
        // undo the damage that might have been done by quarto-nav.js in the case of
        // links that we want to consider external
        if (link.dataset.originalHref !== undefined) {
          link.href = link.dataset.originalHref;
        }
      }
    }
  function tippyHover(el, contentFn, onTriggerFn, onUntriggerFn) {
    const config = {
      allowHTML: true,
      maxWidth: 500,
      delay: 100,
      arrow: false,
      appendTo: function(el) {
          return el.parentElement;
      },
      interactive: true,
      interactiveBorder: 10,
      theme: 'quarto',
      placement: 'bottom-start',
    };
    if (contentFn) {
      config.content = contentFn;
    }
    if (onTriggerFn) {
      config.onTrigger = onTriggerFn;
    }
    if (onUntriggerFn) {
      config.onUntrigger = onUntriggerFn;
    }
    window.tippy(el, config); 
  }
  const noterefs = window.document.querySelectorAll('a[role="doc-noteref"]');
  for (var i=0; i<noterefs.length; i++) {
    const ref = noterefs[i];
    tippyHover(ref, function() {
      // use id or data attribute instead here
      let href = ref.getAttribute('data-footnote-href') || ref.getAttribute('href');
      try { href = new URL(href).hash; } catch {}
      const id = href.replace(/^#\/?/, "");
      const note = window.document.getElementById(id);
      if (note) {
        return note.innerHTML;
      } else {
        return "";
      }
    });
  }
  const xrefs = window.document.querySelectorAll('a.quarto-xref');
  const processXRef = (id, note) => {
    // Strip column container classes
    const stripColumnClz = (el) => {
      el.classList.remove("page-full", "page-columns");
      if (el.children) {
        for (const child of el.children) {
          stripColumnClz(child);
        }
      }
    }
    stripColumnClz(note)
    if (id === null || id.startsWith('sec-')) {
      // Special case sections, only their first couple elements
      const container = document.createElement("div");
      if (note.children && note.children.length > 2) {
        container.appendChild(note.children[0].cloneNode(true));
        for (let i = 1; i < note.children.length; i++) {
          const child = note.children[i];
          if (child.tagName === "P" && child.innerText === "") {
            continue;
          } else {
            container.appendChild(child.cloneNode(true));
            break;
          }
        }
        if (window.Quarto?.typesetMath) {
          window.Quarto.typesetMath(container);
        }
        return container.innerHTML
      } else {
        if (window.Quarto?.typesetMath) {
          window.Quarto.typesetMath(note);
        }
        return note.innerHTML;
      }
    } else {
      // Remove any anchor links if they are present
      const anchorLink = note.querySelector('a.anchorjs-link');
      if (anchorLink) {
        anchorLink.remove();
      }
      if (window.Quarto?.typesetMath) {
        window.Quarto.typesetMath(note);
      }
      // TODO in 1.5, we should make sure this works without a callout special case
      if (note.classList.contains("callout")) {
        return note.outerHTML;
      } else {
        return note.innerHTML;
      }
    }
  }
  for (var i=0; i<xrefs.length; i++) {
    const xref = xrefs[i];
    tippyHover(xref, undefined, function(instance) {
      instance.disable();
      let url = xref.getAttribute('href');
      let hash = undefined; 
      if (url.startsWith('#')) {
        hash = url;
      } else {
        try { hash = new URL(url).hash; } catch {}
      }
      if (hash) {
        const id = hash.replace(/^#\/?/, "");
        const note = window.document.getElementById(id);
        if (note !== null) {
          try {
            const html = processXRef(id, note.cloneNode(true));
            instance.setContent(html);
          } finally {
            instance.enable();
            instance.show();
          }
        } else {
          // See if we can fetch this
          fetch(url.split('#')[0])
          .then(res => res.text())
          .then(html => {
            const parser = new DOMParser();
            const htmlDoc = parser.parseFromString(html, "text/html");
            const note = htmlDoc.getElementById(id);
            if (note !== null) {
              const html = processXRef(id, note);
              instance.setContent(html);
            } 
          }).finally(() => {
            instance.enable();
            instance.show();
          });
        }
      } else {
        // See if we can fetch a full url (with no hash to target)
        // This is a special case and we should probably do some content thinning / targeting
        fetch(url)
        .then(res => res.text())
        .then(html => {
          const parser = new DOMParser();
          const htmlDoc = parser.parseFromString(html, "text/html");
          const note = htmlDoc.querySelector('main.content');
          if (note !== null) {
            // This should only happen for chapter cross references
            // (since there is no id in the URL)
            // remove the first header
            if (note.children.length > 0 && note.children[0].tagName === "HEADER") {
              note.children[0].remove();
            }
            const html = processXRef(null, note);
            instance.setContent(html);
          } 
        }).finally(() => {
          instance.enable();
          instance.show();
        });
      }
    }, function(instance) {
    });
  }
      let selectedAnnoteEl;
      const selectorForAnnotation = ( cell, annotation) => {
        let cellAttr = 'data-code-cell="' + cell + '"';
        let lineAttr = 'data-code-annotation="' +  annotation + '"';
        const selector = 'span[' + cellAttr + '][' + lineAttr + ']';
        return selector;
      }
      const selectCodeLines = (annoteEl) => {
        const doc = window.document;
        const targetCell = annoteEl.getAttribute("data-target-cell");
        const targetAnnotation = annoteEl.getAttribute("data-target-annotation");
        const annoteSpan = window.document.querySelector(selectorForAnnotation(targetCell, targetAnnotation));
        const lines = annoteSpan.getAttribute("data-code-lines").split(",");
        const lineIds = lines.map((line) => {
          return targetCell + "-" + line;
        })
        let top = null;
        let height = null;
        let parent = null;
        if (lineIds.length > 0) {
            //compute the position of the single el (top and bottom and make a div)
            const el = window.document.getElementById(lineIds[0]);
            top = el.offsetTop;
            height = el.offsetHeight;
            parent = el.parentElement.parentElement;
          if (lineIds.length > 1) {
            const lastEl = window.document.getElementById(lineIds[lineIds.length - 1]);
            const bottom = lastEl.offsetTop + lastEl.offsetHeight;
            height = bottom - top;
          }
          if (top !== null && height !== null && parent !== null) {
            // cook up a div (if necessary) and position it 
            let div = window.document.getElementById("code-annotation-line-highlight");
            if (div === null) {
              div = window.document.createElement("div");
              div.setAttribute("id", "code-annotation-line-highlight");
              div.style.position = 'absolute';
              parent.appendChild(div);
            }
            div.style.top = top - 2 + "px";
            div.style.height = height + 4 + "px";
            div.style.left = 0;
            let gutterDiv = window.document.getElementById("code-annotation-line-highlight-gutter");
            if (gutterDiv === null) {
              gutterDiv = window.document.createElement("div");
              gutterDiv.setAttribute("id", "code-annotation-line-highlight-gutter");
              gutterDiv.style.position = 'absolute';
              const codeCell = window.document.getElementById(targetCell);
              const gutter = codeCell.querySelector('.code-annotation-gutter');
              gutter.appendChild(gutterDiv);
            }
            gutterDiv.style.top = top - 2 + "px";
            gutterDiv.style.height = height + 4 + "px";
          }
          selectedAnnoteEl = annoteEl;
        }
      };
      const unselectCodeLines = () => {
        const elementsIds = ["code-annotation-line-highlight", "code-annotation-line-highlight-gutter"];
        elementsIds.forEach((elId) => {
          const div = window.document.getElementById(elId);
          if (div) {
            div.remove();
          }
        });
        selectedAnnoteEl = undefined;
      };
        // Handle positioning of the toggle
    window.addEventListener(
      "resize",
      throttle(() => {
        elRect = undefined;
        if (selectedAnnoteEl) {
          selectCodeLines(selectedAnnoteEl);
        }
      }, 10)
    );
    function throttle(fn, ms) {
    let throttle = false;
    let timer;
      return (...args) => {
        if(!throttle) { // first call gets through
            fn.apply(this, args);
            throttle = true;
        } else { // all the others get throttled
            if(timer) clearTimeout(timer); // cancel #2
            timer = setTimeout(() => {
              fn.apply(this, args);
              timer = throttle = false;
            }, ms);
        }
      };
    }
      // Attach click handler to the DT
      const annoteDls = window.document.querySelectorAll('dt[data-target-cell]');
      for (const annoteDlNode of annoteDls) {
        annoteDlNode.addEventListener('click', (event) => {
          const clickedEl = event.target;
          if (clickedEl !== selectedAnnoteEl) {
            unselectCodeLines();
            const activeEl = window.document.querySelector('dt[data-target-cell].code-annotation-active');
            if (activeEl) {
              activeEl.classList.remove('code-annotation-active');
            }
            selectCodeLines(clickedEl);
            clickedEl.classList.add('code-annotation-active');
          } else {
            // Unselect the line
            unselectCodeLines();
            clickedEl.classList.remove('code-annotation-active');
          }
        });
      }
  const findCites = (el) => {
    const parentEl = el.parentElement;
    if (parentEl) {
      const cites = parentEl.dataset.cites;
      if (cites) {
        return {
          el,
          cites: cites.split(' ')
        };
      } else {
        return findCites(el.parentElement)
      }
    } else {
      return undefined;
    }
  };
  var bibliorefs = window.document.querySelectorAll('a[role="doc-biblioref"]');
  for (var i=0; i<bibliorefs.length; i++) {
    const ref = bibliorefs[i];
    const citeInfo = findCites(ref);
    if (citeInfo) {
      tippyHover(citeInfo.el, function() {
        var popup = window.document.createElement('div');
        citeInfo.cites.forEach(function(cite) {
          var citeDiv = window.document.createElement('div');
          citeDiv.classList.add('hanging-indent');
          citeDiv.classList.add('csl-entry');
          var biblioDiv = window.document.getElementById('ref-' + cite);
          if (biblioDiv) {
            citeDiv.innerHTML = biblioDiv.innerHTML;
          }
          popup.appendChild(citeDiv);
        });
        return popup.innerHTML;
      });
    }
  }
});
</script>
</div> <!-- /content -->




</body></html>